﻿//Control transformation
using Essential.Metamodel;
using Essential.Plugin;

namespace Plugin
{
    transformation Main()
    {
        PluginDeclaration plugin = Manifest.Generator;
        EssentialModel    model = Model.model;

        ConvertMetamodel(model, plugin);
    }

    //Entry point
    //Preserve this signature to call the plugin
    transformation ConvertMetamodel(EssentialModel model, PluginDeclaration plugin)
    {
        //Debuging models
        model  > "meta-java/model/model.ess";
		plugin > "meta-java/model/generator.ess";

        //Generate java code
        foreach(Namespace ns in model.Namespaces)
        {
        	foreach (Class cl in ns.Classes)
        	{
		        Templates.genClass(model, ns, cl, plugin) > "meta-java/$ns.Name$/$cl.Name$.java";
        	}
        	foreach (Enum en in ns.Enums)
        	{
		        Templates.genEnum(model, ns, en, plugin) > "meta-java/$ns.Name$/$en.Name$.java";
        	}
	    }
    }
}
